package Demo;

import fit.*;
import java.util.*;

public class CalendarFixture extends ColumnFixture {
	
	// inputs
	
    public Date from;
    public Date to;
    
    // outputs
    
    public long actual() {
        return (to.getTime()-from.getTime())/(1000*60*60*24);
    }
    public int thirty360() {
        return 30 * (month(to)-month(from)) + (day(to)-day(from));
    }

	// helpers

    static Calendar calendar = new GregorianCalendar();

    static int day(Date date) {
        return get(date,Calendar.DAY_OF_MONTH);
    }
    static int month(Date date) {
        return get(date,Calendar.MONTH);
    }
    static int year(Date date) {
        return get(date,Calendar.YEAR);
    }

    static int get(Date date, int field) {
        calendar.setTime(date);
        return calendar.get(field);
    }
}
