package Demo;

import fit.*;
import java.util.*;
import java.text.*;

public class OldCalendarFixture extends ColumnFixture {

	// Fixture //////////////////////////////////

	public Date From;
	public Date To;

	public int Actual() {
		long msec = To.getTime() - From.getTime();
		return (int)Math.round((double)msec/(1000*60*60*24));
	}

	public int Thirty360() throws Exception {
		int fromDays = day(From);
		int toDays = day(To);
		int days = Math.min(toDays,30) - Math.min(fromDays,30);
		int months = month(To) - month(From);
		int years = year(To) - year(From);
		int result = 360*years + 30*months + days;
		if (result < 0) throw new Exception("dates out of order");
		return result;
	}

	public int ThirtyE360() throws Exception {
		int days = Math.min(day(To),30) - Math.min(day(From),30);
                int months = month(To) - month(From);
                int years = year(To) - year(From);
                int result = 360*years + 30*months + days;
                if (result < 0) throw new Exception("dates out of order");
                return result;
	}

        public int ThirtyEplus360() throws Exception {
                int days = Math.min(day(To),30) - Math.min(day(From),30);
                int months = month(To) - month(From);
                int years = year(To) - year(From);
                int result = 360*years + 30*months + days;
                if (result < 0) throw new Exception("dates out of order");
                return result;
        }


	// Main /////////////////////////////////////
	
	public static void main (String args[]){
		FileRunner.main(new String[]{"simple.html", "simple-out.html"});
	}
	
	// Date Format //////////////////////////////
	
	static DateFormat format = new SimpleDateFormat("dd-MMM-yyyy");
	static Calendar calendar = new GregorianCalendar();

	public Object parse (String s, Class type) throws Exception {
		if (type.equals(Date.class))  {return format.parse(s);}
		return super.parse(s,type);
	}	

	static int day(Date date) 	{return get(date,Calendar.DAY_OF_MONTH);}	
	static int month(Date date) 	{return get(date,Calendar.MONTH);}	
	static int year(Date date) 	{return get(date,Calendar.YEAR);}
	
	static int get(Date date, int field) {
		calendar.setTime(date);
		return calendar.get(field);
	}
}
